package cz.moneta.test.regression.commercial.smallbusiness.digital.localtests.banka.client;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.ufo.banka.tasks.BankaTasks;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.dsl.util.data.client.*;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import cz.moneta.test.regression.commercial.smallbusiness.digital.DataPrepare;
import cz.moneta.test.regression.commercial.smallbusiness.digital.TearDown;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;

import static cz.moneta.test.harness.annotations.Environment.PPE;
import static cz.moneta.test.harness.annotations.Environment.TST1;

@TestScenario(name = "Create FON Statutory Authority")
public class CreateFonStatutoryAuthority {

    private NonClient nonPoClient;
    private BankaTasks bankaTasks;

    @BeforeAll
    protected void setUp(Harness harness) {
        nonPoClient = DataPrepare.setUpPo(harness);
    }

    @TestCase(name = "Create FON Statutory Authority", environments = {TST1, PPE})
    @JiraTestCase(id = "SBD-T486")
    public void createFonStatutoryAuthority(Harness harness, @Key(Keys.ufo.banka.banker) Credentials credentials) {
        bankaTasks = harness.tasks().ufo().banka();
        harness.withUfo()
                .openLoginPage()
                .then(bankaTasks.login().withCredentialsAndTurnOffSignpad(credentials))
                .then(bankaTasks.search().findByNewRc(nonPoClient.birthNumber()))
                .then(bankaTasks.newStatutoryAuthority().createStatutoryAuthority(nonPoClient))
                .then(bankaTasks.sharedTasks().storeFullNameAndBirthNumber());

    }

    @AfterEach
    protected void tearDown(Harness harness) {
        TearDown.storeBirthNumberFullNameCifSessionId(harness);
    }
}
